trip <- read.csv("trip.csv", header=TRUE)
trip.cleaningall <- read.csv("ensyu_cleaningall.csv", header=TRUE)
area <- read.csv("s撬n摮f[^.csv", header=TRUE)

trip.cleaningall$aboutday <- as.Date(as.POSIXct(trip.cleaningall$o, tz="Japan") - 3*60*60, tz="Japan")
trip$aboutday <- as.Date(as.POSIXct(trip$ot, tz="Japan") - 3*60*60, tz="Japan")
trip$otposix <- as.POSIXct(trip$ot)
trip.cleaningall$otposix <- as.POSIXct(trip.cleaningall$o)

commutationTmp <- subset(trip.cleaningall, ړI=="o")
commutationKey <- aggregate(list(otposix=commutationTmp$otposix), by=list(j^[ID=commutationTmp$j^[ID, aboutday=commutationTmp$aboutday), FUN=max)
commutation <- merge(commutationTmp, commutationKey)
commutation$commutationMinutes <- difftime(as.POSIXct(commutation$), as.POSIXct(commutation$o), units="min")
commutation$oΓ <- commutation$
commutation$oΎiID <- commutation$\ʎiR[h
commutation$oΎi <- commutation$\ʎi
commutation$shikucodeHome <- commutation$shikucodeO
commutation$LatHome <- commutation$LatO
commutation$LonHome <- commutation$LonO

#tripOnWorkingDay <- subset(trip, paste(trip$[U[R[h, trip$aboutday) %in% targetRecords)

tripFromCompany <- subset(trip, on{ݑR[h==120) #120=
lastTimeFromCompany <- aggregate(list(otposix=as.POSIXct(tripFromCompany$ot)), by=list(j^[ID=tripFromCompany$[U[R[h, aboutday=tripFromCompany$aboutday), FUN=max)

trip$toHome <- trip$n{ݑR[h==110 #

lastTripFromCompany <- merge(trip.cleaningall, lastTimeFromCompany, by.x=c("otposix", "j^[ID", "aboutday"), by.y=c("otposix", "j^[ID", "aboutday"))
l <- lastTripFromCompany #alias
targetRecords <- merge(l, commutation[c("oΓ", "oΎiID", "oΎi", "commutationMinutes", "j^[ID", "aboutday", "LatHome", "LonHome", "shikucodeHome")], by.x=c("j^[ID", "aboutday"), by.y=c("j^[ID", "aboutday"))
targetRecords <- merge(targetRecords, trip[c("gbvID", "toHome")])
#ދΌo΂Ăli΁Hj
targetRecords <- subset(targetRecords, as.POSIXct(targetRecords$oΓ) < as.POSIXct(targetRecords$o))

tmp <- targetRecords #alias
tmp <- merge(tmp, area[c("s撬R[h", "ƒnn")], by.x="shikucodeHome", by.y="s撬R[h")
colnames(tmp)[which(colnames(tmp) == "ƒnn")] <- "ӏƒnn"
tmp <- merge(tmp, area[c("s撬R[h", "ƒnn")], by.x="shikucodeO", by.y="s撬R[h")
colnames(tmp)[which(colnames(tmp) == "ƒnn")] <- "Ўӏƒnn"
tmp <- merge(tmp, area[c("s撬R[h", "ƒnn")], by.x="shikucodeD", by.y="s撬R[h")
colnames(tmp)[which(colnames(tmp) == "ƒnn")] <- "揤ƒnn"
tmp$distanceDestToHome_m <-
 6371000 * acos(
  sin(tmp$LatD/180*pi)*sin(tmp$LatHome/180*pi)
  + cos(tmp$LatD/180*pi)*cos(tmp$LatHome/180*pi)*cos((tmp$LonD-tmp$LonHome)/180*pi)
 )

averageDepartureTimeFromCompany <- aggregate(list(ϑގЎ=as.POSIXlt(tmp$o)$hour*60+as.POSIXlt(tmp$o)$min),
              by=list(j^[ID=tmp$j^[ID),
              FUN=mean)
tmp <- merge(tmp, averageDepartureTimeFromCompany)

t <- tmp
hasTachiyoriLastWeek <- function(r) {
  aboutday <- as.Date(r["aboutday"])
  same <- subset(t, j^[ID==r["j^[ID"])
  same_tachiyori <- subset(same, !(toHome))
  return(any(seq(aboutday-1, aboutday-7, by=-1) %in% same_tachiyori$aboutday))
}
data <- data.frame(
 monitorID=t$j^[ID,
 tripID=t$gbvID,
 aboutday=t$aboutday,
 purposeID=t$ړIR[h,
 purpose=t$ړI,
 tachiyori=!(t$toHome),
 averageDepartureTimeFromCompany=t$ϑގЎ,
 arrivalTimeAtCompany=as.POSIXlt(t$oΓ)$hour*60+as.POSIXlt(t$oΓ)$min,
 departureTimeFromCompany=as.POSIXlt(t$o)$hour*60+as.POSIXlt(t$o)$min,
 workingMinutes=difftime(as.POSIXct(t$o), as.POSIXct(t$oΓ), units="min"),
 commutationMinutes=t$commutationMinutes,
 commutationMethodID=t$oΎiID,
 commutationMethod=t$oΎi,
 wday=weekdays(t[["aboutday"]]),
 landpriceAroundCompany=t$Ўӏƒnn,
 landpriceAroundTachiyori=t$揤ƒnn,
 landpriceAroundHome=t$ӏƒnn,
 age=t$N,
 genderID=t$ʃR[h,
 gender=t$,
 LatCompany=t$LatO,
 LonCompany=t$LonO,
 LatTachiyori=t$LatD,
 LonTachiyori=t$LonD,
 LatHome=t$LatHome,
 LonHome=t$LonHome,
 nearCompany=(!(t$toHome))&(t$OD_m<t$distanceDestToHome_m),
 tachiyoriLastWeek=apply(t, 1, hasTachiyoriLastWeek)
)

